[[FX]]

// Samplers
sampler2D buf0 = sampler_state
{
	Address = Clamp;
};

// Uniforms
float4 blurAlpha = {0.5, 0, 0, 0};

// Contexts
context MOTIONBLUR
{
	VertexShader = compile GLSL VS_FSQUAD;
	PixelShader = compile GLSL FS_BLURPASS;
	
     ZWriteEnable = false;
     ZFunc = Always;
     BlendMode = Blend;
}

context COPYPASS
{
	VertexShader = compile GLSL VS_FSQUAD;
	PixelShader = compile GLSL FS_COPY;
	
	ZWriteEnable = false;
	ZFunc = Always;
}

[[VS_FSQUAD]]
// =================================================================================================

uniform mat4 projMat;
attribute vec3 vertPos;
varying vec2 texCoords;
				
void main( void )
{
	texCoords = vertPos.xy; 
	gl_Position = projMat * vec4( vertPos, 1 );
}


[[FS_BLURPASS]]
// =================================================================================================

uniform sampler2D buf0;
varying vec2 texCoords;
uniform vec4 blurAlpha;

void main( void )
{
	vec4 albedo = texture2D( buf0, texCoords );
	gl_FragColor = vec4(albedo.xyz, blurAlpha.x);
}
	

[[FS_COPY]]
// =================================================================================================

uniform sampler2D buf0;
varying vec2 texCoords;

void main( void )
{
	vec4 col0 = texture2D( buf0, texCoords );	// bla

	gl_FragColor = col0;
}
